"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generate_unique_id_1 = __importDefault(require("../../../utils/generate-unique-id"));
class RequestEvent {
    constructor(init) {
        Object.assign(this, init);
        this._setRequestOptionsTracking(this.reqOpts);
        this.id = (0, generate_unique_id_1.default)();
    }
    _setRequestOptionsTracking(reqOpts) {
        reqOpts.on('headerChanged', changedHeader => {
            this._requestInfo.headers[changedHeader.name] = changedHeader.value;
        });
        reqOpts.on('headerRemoved', name => {
            delete this._requestInfo.headers[name];
        });
    }
    async setMock(mock) {
        await this.setMockFn(this.id, mock);
    }
    get requestOptions() {
        return this.reqOpts;
    }
    get isAjax() {
        return this._requestInfo.isAjax;
    }
}
exports.default = RequestEvent;module.exports = exports.default;

